/***************************************************************************
 *   Copyright (C) 2010 by Martin Burgemeister, Mathis Lindemann           *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef UCQBLOCKDIALOG_H_
#define UCQBLOCKDIALOG_H_

#include <QtGui/QDialog>
#include "ui/ui_ucblockdialog.h"
#include "data/TableModel.h"
#include <QString>

/**
 * \class UCQBlockDialog
 * \brief Dialog for creating new blocks.
 *
 * This dialog allows the user to create new blocks with a blockname and a lower
 * and upper bound. The block is added to the TableModel when the user clicks
 * Ok and all input is valid.
 *
 * \author Martin Burgemeister <Martin.Burgemeister@gmx.de>,
 *         Mathis Lindemann <MathisLindemann@gmx.net>
 * \version 1.0
 * \date 16 August 2010
 *
 * \see TableModel
 */
class UCQBlockDialog: public QDialog
{

Q_OBJECT

public:
    UCQBlockDialog ( QWidget*, TableModel* );

private:
    /**
     * \brief Ui object.
     */
    Ui::UCQBlockDialog ui_;
    /**
     * \brief The TableModel in which to set the block.
     */
    TableModel* tableModel_;

protected slots:
    void on_okButton_clicked     ();
    void on_cancelButton_clicked ();
};

#endif /* UCQBLOCKDIALOG_H_ */
